using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Globalization;
using System.Drawing;
using SlimDX;

namespace Mindshifter
{
    public class ColorConverter : TypeConverter
    {
        public override bool CanConvertFrom(ITypeDescriptorContext context, Type sourceType)
        {
            if (sourceType == typeof(int))
                return true;

            return base.CanConvertFrom(context, sourceType);
        }

        public override bool CanConvertTo(ITypeDescriptorContext context, Type destinationType)
        {
            if (destinationType == typeof(int))
                return true;

            return base.CanConvertTo(context, destinationType);
        }

        public override object ConvertFrom(ITypeDescriptorContext context, CultureInfo culture, object value)
        {
            if (value is int)
            {
                int packed = (int)value;
                return new Color4(Color.FromArgb(packed));
            }

            return base.ConvertFrom(context, culture, value);
        }

        public override object ConvertTo(ITypeDescriptorContext context, CultureInfo culture, 
            object value, Type destinationType)
        {
            if (destinationType == typeof(int))
            {
                Color4 color = (Color4)value;
                //return (int)(((long)color.G << 16) | ((long)color.B << 8) | ((long)color.A));
                return color.ToArgb();
            }

            return base.ConvertTo(context, culture, value, destinationType);
        }
    }
}